Bug 742610 (netcdf-cxx)

Summary: Review Request: netcdf-cxx - Legacy netCDF C++ library
Product: [Fedora] Fedora Reporter: Orion Poplawski <orion>
Component: Package ReviewAssignee: Hedayat Vatankhah <hedayatv>
Status: CLOSED NEXTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: alexl, hedayatv, notting, package-review, tomspur
Target Milestone: ---Flags: hedayatv: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-12-05 19:04:36 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Orion Poplawski 2011-09-30 14:24:16 EDT
Spec URL: http://www.cora.nwra.com/~orion/fedora/netcdf-cxx.spec
SRPM URL: http://www.cora.nwra.com/~orion/fedora/netcdf-cxx-4.2-1.fc15.src.rpm
Description:
Legacy netCDF C++ library.  This library is provided for backward
compatibility only. New C++ development should be done with the netCDF
CXX4 C++ library.
Comment 1 Thomas Spura 2011-10-01 07:08:54 EDT
- The description is the same like summary, so non existent...
  How about:
  http://www.unidata.ucar.edu/software/netcdf/docs/faq.html#whatisit
- isa is missing:
  https://fedoraproject.org/wiki/PackagingGuidelines#Requiring_Base_Package
- The static library needs to R the devel package too, to get the headers.

All of this also applies to the CXX4 bug #742605.
Comment 2 Michael Schwendt 2011-10-02 16:14:35 EDT
> %package static
> ...
> Requires:       %{name} = %{version}-%{release}

This makes no sense. The -static package does not need the shared library.
Comment 3 Orion Poplawski 2011-10-03 10:39:23 EDT
(In reply to comment #1)
> - The description is the same like summary, so non existent...
>   How about:
>   http://www.unidata.ucar.edu/software/netcdf/docs/faq.html#whatisit

The main netcdf package contains the full description.  This is just the (legacy) C++
API, I don't see the need to reproduce it.

> - isa is missing:
>   https://fedoraproject.org/wiki/PackagingGuidelines#Requiring_Base_Package
> - The static library needs to R the devel package too, to get the headers.
> 
> All of this also applies to the CXX4 bug #742605.

Fixed
Spec URL: http://www.cora.nwra.com/~orion/fedora/netcdf-cxx.spec
SRPM URL: http://www.cora.nwra.com/~orion/fedora/netcdf-cxx-4.2-2.fc15.src.rpm

* Mon Oct 3 2011 Orion Poplawski <orion@cora.nwra.com> - 4.2-2
- Use %%{?_isa} in Requires
- Change -static to require the -devel package
Comment 4 Orion Poplawski 2011-10-25 18:46:37 EDT
Anyone able to review this?  I really need to get it into rawhide since the netcdf 4.2.0 package there no longer includes this.
Comment 5 Hedayat Vatankhah 2011-12-02 04:42:16 EST
I'll review this package.
Comment 6 Hedayat Vatankhah 2011-12-02 16:15:24 EST
[OK] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.

% rpmlint *
netcdf-cxx.i686: W: shared-lib-calls-exit /usr/lib/libnetcdf_c++.so.4.2.0 exit@GLIBC_2.0
netcdf-cxx.x86_64: W: shared-lib-calls-exit /usr/lib64/libnetcdf_c++.so.4.2.0 exit@GLIBC_2.2.5
netcdf-cxx-devel.i686: W: no-documentation
netcdf-cxx-devel.x86_64: W: no-documentation
netcdf-cxx-static.i686: W: spelling-error Summary(en_US) libs -> lobs, lib, lbs
netcdf-cxx-static.i686: W: spelling-error %description -l en_US libs -> lobs, lib, lbs
netcdf-cxx-static.i686: W: no-documentation
netcdf-cxx-static.x86_64: W: spelling-error Summary(en_US) libs -> lobs, lib, lbs
netcdf-cxx-static.x86_64: W: spelling-error %description -l en_US libs -> lobs, lib, lbs
netcdf-cxx-static.x86_64: W: no-documentation
10 packages and 1 specfiles checked; 0 errors, 10 warnings.

• A few notes:
∘ Isn't there any documentation for this library?
∘ calling exit might be solvable talking to upstream
∘ 'libs' might be replaced by 'libraries'

[OK] MUST: The package must be named according to the Package Naming Guidelines .
[OK] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[OK] MUST: The package must meet the Packaging Guidelines .

• A few notes
∘ consider removing %defattr (http://fedoraproject.org/wiki/Packaging/Guidelines#File_Permissions)
∘ consider removing %clean (http://fedoraproject.org/wiki/Packaging/Guidelines#.25clean)
∘ consider removing the buildroot tag (http://fedoraproject.org/wiki/Packaging/Guidelines#BuildRoot_tag)

[OK] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[OK] MUST: The License field in the package spec file must match the actual license. 
[OK] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[OK] MUST: The spec file must be written in American English.
[OK] MUST: The spec file for the package MUST be legible.
[OK] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task.

d32b20c00f144ae6565d9e98d9f6204c  netcdf-cxx-4.2.tar.gz

[OK] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[N/A] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. 
[OK] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[N/A] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[OK] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[OK] MUST: Packages must NOT bundle copies of system libraries.
[N/A] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. 
[OK] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. 
[OK] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[OK] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[OK] MUST: Each package must consistently use macros. 
[OK] MUST: The package must contain code, or permissable content. 
[N/A] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). 
[OK] MUST: If a package includes something as %doc, it must not affect the runtime of the application. 
[OK] MUST: Header files must be in a -devel package. 
[OK] MUST: Static libraries must be in a -static package. 
[OK] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. 
[OK] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} 
[OK] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[N/A] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. 
[OK] MUST: Packages must not own files or directories already owned by other packages. 
[OK] MUST: All filenames in rpm packages must be valid UTF-8. 


[N/A] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. 
[N/A] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. 
[OK] SHOULD: The reviewer should test that the package builds in mock. (built in Koji)
[OK] SHOULD: The package should compile and build into binary rpms on all supported architectures.  (see above)
[N/A] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[OK] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[N/A] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. 
[N/A] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.
[N/A] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[N/A] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.
Comment 7 Hedayat Vatankhah 2011-12-02 16:18:10 EST
Since there are no problems but just some nice-to-have items, I consider this package to be APPROVED.
Comment 8 Orion Poplawski 2011-12-05 16:48:51 EST
(In reply to comment #6)
> • A few notes:
> ∘ Isn't there any documentation for this library?

There is an info file.  I've added examples and the pdf version to the -devel %doc as well.

> ∘ calling exit might be solvable talking to upstream

This is a legacy library that is only around for compatibility, so no real changes are going to be made.

> ∘ 'libs' might be replaced by 'libraries'

Done.

> • A few notes
> ∘ consider removing %defattr
> (http://fedoraproject.org/wiki/Packaging/Guidelines#File_Permissions)
> ∘ consider removing %clean
> (http://fedoraproject.org/wiki/Packaging/Guidelines#.25clean)
> ∘ consider removing the buildroot tag
> (http://fedoraproject.org/wiki/Packaging/Guidelines#BuildRoot_tag)

Done

New Package SCM Request
=======================
Package Name: netcdf-cxx
Short Description: Legacy netCDF C++ library
Owners: orion
Branches: 
InitialCC:
Comment 9 Gwyn Ciesla 2011-12-05 18:41:58 EST
Git done (by process-git-requests).
Comment 10 Orion Poplawski 2011-12-05 19:04:36 EST
Checked in and built